;angular.module('Landers.angular')
    .directive('landersNameValueInputer', ['$compile', 'Flat', 'Dialog', 'List', function($compile, Flat, Dialog, List) {
        var buildHtml = {
            lister: function(model_key, view_key){
                var html = '';
                html += '<div class="relative">';
                html += '   <a ng-click="landersNameValuesEdit(\'%VAR1%\')" class="btn btn-xs btn-primary absolute right-top"><i class="glyphicon glyphicon-plus"></i></a>';
                html += '</div>';
                html += '<ul class="hlist list">';
                html += '    <li ng-repeat="item in %VAR2%" class="mr20 list-item">';
                html += '        <a ng-click="landersNameValuesEdit(\'%VAR1%\', $index)" class="">{{item.name}}：{{item.value}}</a>';
                html += '        <a ng-click="landersNameValuesRemove($event, \'%VAR1%\', \'%VAR2%\')" class="btn btn-warning btn-xs ml5"><i class="glyphicon glyphicon-minus"></i></a>';
                html += '    </li>';
                html += '</ul>';
                html += '<input ng-model="%VAR1%" type="hidden"/>';
                html = Landers.utils.str.replace(html, '%VAR1%', model_key);
                html = Landers.utils.str.replace(html, '%VAR2%', view_key);
                return html;
            },
            form: function(){
                var html = '';
                html += '<form class="form-horizontal">';
                html += '   <table cellpadding="0" cellspacing="0" border="0" class="stereo form-table">';
                html += '   <tr>';
                html += '       <td><label class="control-label">名称</label></td>';
                html += '       <td><div class="control-input">';
                html += '           <input ng-model="$runtime.nvi.item.name" maxlength="30" value="" type="text" class="form-control" ng-if="!$runtime.nvi.options.names"/>';
                html += '           <select ng-model="$runtime.nvi.item.name" class="form-control" ng-if="$runtime.nvi.options.names">';
                html += '               <option ng-repeat="item in $runtime.nvi.options.names" value="{{item}}">{{item}}</option>';
                html += '           </select>'
                html += '       </div></td>';
                html += '   </tr>';
                html += '   <tr>';
                html += '       <td><label class="control-label">数据</label></td>';
                html += '       <td><div class="control-input"><textarea ng-model="$runtime.nvi.item.value" value="" type="text" class="form-control"></textarea></div></td>';
                html += '   </tr>';
                html += '   </table>';
                html += '</form>';
                return html;
            }
        };

        var listers = {};

        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                var model_key = $attrs['nviModel'];
                var view_key = $attrs['nviView'];
                var options = $attrs['nviOptions'];
                if (options) {
                    options = Landers.utils.str.replace(options, "'", '"');
                    options = options ? angular.fromJson(options) : null;
                }
                Flat.set($scope, '$runtime.nvi.options', options);
                angular_scope_apply($scope);

                var html = buildHtml.lister(model_key, view_key);
                var el = $compile(html)($scope);
                $element.css({height:'100%'}).append(el);
                $element.find('.list').css({
                    'margin-right':$element.find('.btn').width() + 20
                });

                (function(){
                    var lister = List.make($scope, view_key).data([]);
                    $scope.$watch(model_key, function(model){
                        if (model) lister.data(model);
                    });

                    listers[model_key] = lister;
                })();

                if (!$scope.landersNameValuesEdit) {
                    angular.extend($scope, {
                        landersNameValuesEdit : function(model_key, $index){
                            var lister = listers[model_key];
                            var listitem = $index !== undefined ? lister.data()[$index] : {};
                            var clone_listitem = listitem ? angular.extend({}, listitem) : {};
                            Flat.set($scope, '$runtime.nvi.item', clone_listitem);
                            setTimeout(function(){
                                Dialog.show($scope, {
                                    title   : $attrs['nviName'],
                                    content : buildHtml.form(),
                                    width   : 350,
                                    lock    : true,
                                    fixed   : true,
                                    effect  : 'vmove1',
                                    onload  : function(){
                                    },
                                    yes     : function(){
                                        var nviItem = Flat.get($scope, '$runtime.nvi.item');
                                        if (!nviItem.name ||
                                            !nviItem.name.length ||
                                            !nviItem.value ||
                                            !nviItem.value.length
                                        ) {
                                            alert('数据输入不完整');
                                            return false;
                                        }

                                        var check_exists = function(){
                                            var index = lister.data().findIndex(function(item){
                                                return item.name == nviItem.name
                                            });

                                            return index >-1 && index != $index;
                                        };

                                        if (check_exists()) {
                                            alert('【' + nviItem.name + '】已经存在');
                                            return false;
                                        }

                                        if (listitem) {
                                            // 不能直接赋值 listitem = nviItem;
                                            angular.extend(listitem, nviItem);
                                            angular_scope_apply($scope);
                                        } else {
                                            lister.append(angular.extend({}, nviItem));
                                            Flat.set($scope, model_key, angular.toJson(lister.data()));
                                        }
                                    },
                                    no      : true
                                });
                            }, 200);
                        },
                        landersNameValuesRemove : function($event, model_key, view_key){
                            var lister = listers[model_key];
                            lister.item.remove($event);
                            Flat.set($scope, model_key, angular.toJson(lister.data()));
                        }
                    });
                }
            }
        }
    }]);